/*******************************************************************************
Copyright (c) 2021, Jan Koester jan.koester@gmx.net
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

#include <iostream>
#include <algorithm>

#include <cstring>

#include <dirent.h>
#include <unistd.h>

#include "fresh.h"

int main(int argc,char *argv[]){
    std::string input;
    for(;;){
INPUT:
        input.clear();
        std::cin >> input;
        
        if(input.length()==0)
            goto INPUT;
        else if(input=="exit")
            break;
        
        class args {
        public:
            args(){
                nextargs=nullptr;
            }
            ~args(){
                delete nextargs;
            }
            std::string arg;
            args                  *nextargs;
        }*ftargs=nullptr,*ltargs=nullptr;
        
        unsigned long spos=0,amount=0;
        
        for(int epos=0; epos<=input.length(); ++epos){
            if(input[epos]==' ' || epos==input.length()){
                if(ftargs){
                    ltargs->nextargs=new args;
                    ltargs=ltargs->nextargs;
                }else{
                    ftargs=new args;
                    ltargs=ftargs;
                }
                std::string buf;
                buf=input.substr(spos,epos);
                if(epos<(input.length()-1))
                    spos=++epos;
                ltargs->arg=buf;
                ++amount;
            }
        }
        
        char **cargs=nullptr;
        cargs=new char*[amount+1];
        
        int capos=0;
        
        for(args *curargs=ftargs; curargs; curargs=curargs->nextargs){
            cargs[capos]=new char[curargs->arg.length()+1];
            std::copy(curargs->arg.begin(),curargs->arg.end(),cargs[capos]);
            cargs[capos][curargs->arg.length()]='\0';
            capos++;
        }
        
        cargs[capos]=nullptr;
        
        if(strcmp(cargs[0],"cd")==0){
            if(chdir(cargs[1])!=0){
                std::cerr << "Dir: " << cargs[1] << "not found !" << std::endl;
            }
            goto INPUT;
        }else if(strcmp(cargs[0],"ls")==0){
            DIR *d;
            struct dirent *dir;
            const char *rdir;
            char rbuf[512];
            if(cargs[1]!=nullptr)
                rdir=cargs[1];
            else
                rdir=getcwd(rbuf,512);
            d = opendir(rdir);
            if (d) {
                while ((dir = readdir(d)) != nullptr) {
                    std::cout << dir->d_name << std::endl;
                }
                closedir(d);
            }
            goto INPUT;
        }

        int pid,i=1;
        for(const char *value=PATH[i]; value; value=PATH[++i]){
            DIR *d;
            struct dirent *dir;
            d = opendir(value);
            if (d) {
                while ((dir = readdir(d)) != nullptr) {
                    if(strcmp(cargs[0],dir->d_name)==0){
                        pid = fork();
                        if (pid == 0){
                            std::string execbuf=value; execbuf+='/'; execbuf+=cargs[0];
                            execv(execbuf.c_str(),cargs);
                            return 0;
                        }
                        break;
                    }
                }
                closedir(d);
            }
        }

        for(i=0; i<amount; i++)
            delete [] cargs[i];
        delete[] cargs;
    }
    return 0;
}
